<?php
/****************************************************************
 * This file is part of InFrame
 * Copyright (c) 2008 Richard Tong. All Rights Reserved.
 * 
 * Licensed under the terms of the GNU General Public License.
 * See http://opensource.org/licenses/gpl-license.php
 * 
 ****************************************************************/

// If config file or database doesn't exist, we send user to setup page
$configFile = "../Config/InFrame.config.php";
if (!file_exists($configFile) || !Database::dbExists("../Data/Config"))
{
  header("Location: setup.php");
}

session_start();
require_once($configFile);
$thisPage = $_SERVER["PHP_SELF"];
$op = $_GET["op"];
$continue = false;

if (!isset($op))
	$op = "np";

if (User::isLoggedIn() || ($op == "clogin" && isset($_POST["name"]) && isset($_POST["pw"])))
{
	$continue = true;
}
else
	Page::renderLogin(false);
	
if ($continue)
{
	switch($op)
	{
	case "np":
	case "pref":
	case "cp":
	case "ec":
		Page::renderAdmin($op, false);
		break;
	case "epl":
		Page::listPosts();
		break;
	case "cnp":
		$f = ABSP."/Data/Image/".str_replace(" ", "_", basename($_FILES['photoFilename']['name']));
		move_uploaded_file ($_FILES['photoFilename']['tmp_name'], $f);
		if (!Database::dbExists(ABSP."/Data/InFrame"))
			Photo::createDB(ABSP."/Data/InFrame");
		if (!Database::dbExists(ABSP."/Data/Comments"))
			Comments::createDB(ABSP."/Data/Comments");
		if (!Database::dbExists(ABSP."/Data/Exif"))
			Exif::createDB(ABSP."/Data/Exif");
		if (!Database::dbExists(ABSP."/Data/Ratings"))
			Ratings::createDB(ABSP."/Data/Ratings");
		Photo::process($f);
		if (filesize($f) > 1000000)
			sleep(floor(filesize($f)/1000000));  // Large photos take some time to process
		if (Photo::savePost(ABSP."/Data/InFrame", str_replace(" ", "_", basename($_FILES['photoFilename']['name'])), strip_tags($_POST["photoTitle"]), strip_tags($_POST["photoCaption"]), str_replace("\n", "<br />", strip_tags($_POST["photoDesc"]))))
		{
			Exif::saveExif(ABSP."/Data/Exif", Photo::totalPosts()-1, $f);
			if ($_POST["delete"])
				unlink($f);
			unset($op);
			header("Location: ".URLTOP);
		}
		else
			Page::renderAdmin("np", true);
		break;
	case "cpref":
		if (Config::save(ABSP."/Data/Config", $_POST))
		{
			unset($op);
			header("Location: $thisPage?op=pref");
		}
		else
			Page::renderAdmin("pref", true);
		break;
	case "ccp":
		if (User::changePass($_POST["oldPass"], $_POST["newPass"],$_POST["verifyPass"]))
		{
			unset($op);
			session_destroy();
			header("Location: $thisPage");
		}
		else
			Page::renderAdmin("cp", true);
		break;
	case "clogin":
		if (User::validateUser($_POST["name"], $_POST["pw"]))
		{
			$_SESSION["owner"] = $_POST["name"];
			$_SESSION["pw"] = hash("sha1", $_POST["pw"]);
			unset($op);
			header("Location: $thisPage");
		}
		else
		{
			unset($op);
			Page::renderLogin(true);
		}
		break;
	case "lo":
		session_destroy();
		header("Location: ".URLTOP);
		break;
	default:
		header("Location: ".URLTOP);
	}
}

function __autoload($class_name)
{
  require_once '../Class/' . $class_name . '.class.php';
}

?>
