<?php
/****************************************************************
 * This file is part of InFrame
 * Copyright (c) 2008 Richard Tong. All Rights Reserved.
 * 
 * Licensed under the terms of the GNU General Public License.
 * See http://opensource.org/licenses/gpl-license.php
 * 
 ****************************************************************/

class Comments
{
   public static function createDB($dbname)
   {
     $db = new FFDB();
     $schema = array(
     	array("id", FFDB_INT_AUTOINC, "key"),
     	array("photoid", FFDB_INT),
     	array("dateadded", FFDB_STRING),
     	array("ip", FFDB_STRING),
     	array("name", FFDB_STRING),
     	array("homepage", FFDB_STRING),
     	array("comment", FFDB_STRING));
     $db->create($dbname, $schema);
     $db->close();
     unset($db);
     unset($schema);
     unset($dbname);
   }
   
   public static function saveComment($dbname, $id, $na, $ho, $co)
   {
   	 $db = new FFDB();
   	 $db->open($dbname);
     $record["photoid"] = (int)$id;
	 $record["dateadded"] = date('l, M jS Y, \a\t h:ia');
     $record["ip"] = $_SERVER['REMOTE_ADDR']; 
	 if (strlen($na) < 1)
     	$record["name"] = "Anonymous";
     else
     	$record["name"] = $na;
     if (strlen($ho) < 1)
     	$record["homepage"] = "none";
     else
     	$record["homepage"] = $ho;
     $record["comment"] = $co;
     
     $result = $db->add($record);
     $db->close();
     unset($db);
     unset($record);
     if ($result)
     	return true;
     else
     	return false;
	}
   
   public static function saveEditedComment($dbname, $idx, $co)
   {
   	 $db = new FFDB();
   	 $db->open($dbname);
   	 $record = $db->getbykey($idx);
     $record["comment"] = $co;
     
     $result = $db->edit($record);
     $db->close();
     unset($db);
     unset($record);
     if ($result)
     	return true;
     else
     	return false;
	}

   public static function deleteComment($dbname, $idx)
   {
   	 $db = new FFDB();
   	 $db->open($dbname);
   	 $result = $db->removebykey($idx);
   	 $db->cleanup();
     $db->close();
     unset($db);
     return $result;
	}

	public static function deleteAllByID($i)
	{
		$db = new FFDB();
		$db->open(ABSP."/Data/Comments");
		$result = $db->removebyfield("photoid", "/".$i."/i");
		$db->cleanup();
		$db->close();
		unset($db);
		return $result;
   }

	public static function totalComments()
	{
		$db = new FFDB();
		$db->open(ABSP."/Data/Comments");
		$size = $db->size();
		$db->close();
		unset($db);
		return $size;
   }

	public static function totalCommentsByID($i)
	{
		$db = new FFDB();
		$db->open(ABSP."/Data/Comments");
		$records = $db->getbyfield("photoid", "/".$i."/i");
		$db->close();
		unset($db);
		return count($records);
   }

	public static function isUnique($i)
	{
		$db = new FFDB();
		$db->open(ABSP."/Data/Comments");
		$records = $db->getbyfield("photoid", "/".$i."/i");
		$db->close();
		unset($db);
		$ipAddr = $_SERVER["REMOTE_ADDR"];
		$unique = true;
		if (count($records) > 0)  // there are some comments for this photo
		{
			foreach ($records as $record)
				if ($ipAddr == $record["ip"])
					$unique = false;
		}
		return $unique;
   }

	public static function showComments($i)
	{
		$db = new FFDB();
		$db->open(ABSP."/Data/Comments");
		$records = $db->getbyfield("photoid", "/".$i."/i");
		$db->close();
		unset($db);
		foreach ($records as $record)
		{
			if (User::isLoggedIn())
				echo "<p class=\"codate\"><a href=\"".URLTOP."index.php?op=dco&id=".$i."&idx=".$record["id"]."\">
				<img src=\"".URLTOP."Theme/".Config::theme()."/delete.png\" title=\"Delete comment\" /></a>
				On ".$record["dateadded"].", ";
			else
				echo "<p class=\"codate\">On ".$record["dateadded"].", ";
			if ($record["homepage"] == "none")
				echo $record["name"];
			else
				echo "<a href=\"".$record["homepage"]."\" title=\"".$record["homepage"]."\">".$record["name"]."</a>";
			if (User::isLoggedIn())
				echo " (<a href=\"".URLTOP."index.php?op=bco&ip=".$record["ip"]."&id=".$i."\" title=\"block this IP\">".$record["ip"]."</a>) ";
			echo " said:</p>\n";
			if (User::isLoggedIn())
			{
				echo "<form method=\"post\" action=\"".URLTOP."index.php?op=cec&id=".$i."&idx=".$record["id"]."\">";
				echo "<textarea class=\"formInput\" name=\"comment\" cols=\"60\" rows=\"2\">".str_replace("\\", "", $record["comment"])."</textarea>";
				echo "<input class=\"button\" type=\"submit\" value=\"Update comment\">";
				echo "</form>";
			}
			else
				echo "<p class=\"comment\">".str_replace("\\", "", $record["comment"])."</p>\n";
		}
   }

	public static function showLink($i)
	{
		echo "<a href=\"".URLTOP."index.php?op=co&id=".$i."\" title=\"".Comments::totalCommentsByID($i)." comments\"><img src=\"".URLTOP."Theme/".Config::theme()."/";
		if (Comments::totalCommentsByID($i) > 0)
			echo "commentfull.png";
		else
			echo "commentempty.png";
		echo "\" /></a>\n";
	}
	
}
?>
