<?php
/****************************************************************
 * This file is part of InFrame
 * Copyright (c) 2008 Richard Tong. All Rights Reserved.
 * 
 * Licensed under the terms of the GNU General Public License.
 * See http://opensource.org/licenses/gpl-license.php
 * 
 ****************************************************************/

class Config
{

   public static function createDB($dbname, $bt, $bl, $ow, $pw, $th)
   {
     $db = new FFDB();
     $schema = array(
     	array("id", FFDB_INT_AUTOINC, "key"),
     	array("title", FFDB_STRING),
     	array("byline", FFDB_STRING),
     	array("owner", FFDB_STRING),
     	array("password", FFDB_STRING),
     	array("theme", FFDB_STRING),
     	array("ppp", FFDB_INT),
     	array("pso", FFDB_STRING),
     	array("dimx", FFDB_INT),
     	array("dimy", FFDB_INT),
     	array("allowcomment", FFDB_BOOL),
     	array("allowrating", FFDB_BOOL),
     	array("uniquecomment", FFDB_BOOL),
     	array("uniquerating", FFDB_BOOL),
     	array("captcha", FFDB_BOOL),
     	array("showgraybar", FFDB_BOOL),
     	array("showorig", FFDB_BOOL),
     	array("showrandom", FFDB_BOOL),
     	array("browse", FFDB_BOOL),
     	array("showviews", FFDB_BOOL),
     	array("showposts", FFDB_BOOL),
     	array("showbooks", FFDB_BOOL),
     	array("alwaysdelete", FFDB_BOOL),
     	array("showdate", FFDB_BOOL),
     	array("viewexif", FFDB_BOOL));
     $db->create($dbname, $schema);
     $db->close();
     unset($db);
     unset($schema);
     Config::initial($dbname, $bt, $bl, $ow, $pw, $th);
     unset($dbname);
   }
   
   public static function initial($dbname, $ti, $by, $ow, $pw, $th)
   {
   	 $db = new FFDB();
   	 $db->open($dbname);
     $record["title"] = $ti;
     $record["byline"] = $by;
     $record["owner"] = $ow;
     $record["password"] = $pw;
     $record["theme"] = $th;
     $record["ppp"] = 1;
     $record["pso"] = "Newest first";
     $record["dimx"] = 800;
     $record["dimy"] = 700;
     $record["allowcomment"] = true;
     $record["allowrating"] = false;
     $record["uniquecomment"] = false;
     $record["uniquerating"] = false;
     $record["captcha"] = false;
     $record["showgraybar"] = false;
     $record["showorig"] = false;
     $record["showrandom"] = false;
     $record["browse"] = false;
     $record["showviews"] = true;
     $record["showposts"] = false;
     $record["showbooks"] = false;
     $record["alwaysdelete"] = true;
     $record["showdate"] = true;
     $record["viewexif"] = false;
     $db->add($record);
     $db->close();
     unset($db);
     unset($record);
   }

   public static function save($dbname, $post)
   {
	$db = new FFDB();
	$db->open($dbname);
	$record = $db->getbyindex(0);
	if (strlen($post["blogTitle"]) < 1)
		$record["title"] = "InFrame";
	else
		$record["title"] = $post["blogTitle"];
	if (strlen($post["byline"]) < 1)
		$record["byline"] = "none";
	else
		$record["byline"] = $post["byline"];
     $record["theme"] = $post["theme"];
     $record["ppp"] = (int) $post["ppp"];
     $record["pso"] = $post["pso"];
     $record["dimx"] = (int) $post["dimx"];
     $record["dimy"] = (int) $post["dimy"];
     $record["allowcomment"] = (bool) $post["comment"];
     $record["allowrating"] = (bool) $post["rating"];
     $record["uniquecomment"] = (bool) $post["uniqueComment"];
     $record["uniquerating"] = (bool) $post["uniqueRating"];
     $record["captcha"] = (bool) $post["captcha"];
     $record["showgraybar"] = (bool) $post["graybar"];
     $record["viewexif"] = (bool) $post["viewExif"];
     $record["showorig"] = (bool) $post["original"];
     $record["showrandom"] = (bool) $post["showrandom"];
     $record["browse"] = (bool) $post["browse"];
     $record["showviews"] = (bool) $post["showviews"];
     $record["showposts"] = (bool) $post["showposts"];
     $record["showbooks"] = (bool) $post["showbooks"];
     $record["alwaysdelete"] = (bool) $post["alwaysdelete"];
     $record["showdate"] = (bool) $post["showdate"];
     $result = $db->edit($record);
     $db->close();
     unset($db);
     unset($record);
     if ($result)
     	return true;
     else
     	return false;
   }

   public static function title()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["title"];
   }
   
   public static function byline()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["byline"];
   }
   
   public static function owner()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["owner"];
   }
   
   public static function password()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["password"];
   }
   
   public static function theme()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["theme"];
   }

   public static function ppp()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["ppp"];
   }

   public static function pso()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["pso"];
   }

   public static function dimX()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["dimx"];
   }

   public static function dimY()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["dimy"];
   }

   public static function allowComments()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["allowcomment"];
   }

   public static function allowRatings()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["allowrating"];
   }

   public static function allowViewExif()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["viewexif"];
   }

   public static function requireUniqueComment()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["uniquecomment"];
   }

   public static function requireUniqueRating()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["uniquerating"];
   }

   public static function requireCaptcha()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["captcha"];
   }

   public static function showGrayBar()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["showgraybar"];
   }

   public static function showOriginal()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["showorig"];
   }
   
   public static function showPosts()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["showposts"];
   }
   
   public static function showViews()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["showviews"];
   }
   
   public static function allowRandom()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["showrandom"];
   }
   
   public static function allowBrowse()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["browse"];
   }
   
   public static function showBooks()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["showbooks"];
   }
   public static function alwaysDelete()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["alwaysdelete"];
   }
   public static function showDate()
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $db->close();
   	 unset($db);
   	 return $record["showdate"];
   }
   public static function setPassword($pw)
   {
   	 $db = new FFDB();
   	 $db->open(ABSP."/Data/Config");
   	 $record = $db->getbyindex(0);
   	 $record["password"] = hash("sha1", $pw);
   	 $result = $db->edit($record);
   	 $db->close();
   	 unset($db);
   	 return $result;
   }

}
?>
