<?php
/****************************************************************
 * This file is part of InFrame
 * Copyright (c) 2008 Richard Tong. All Rights Reserved.
 * 
 * Licensed under the terms of the GNU General Public License.
 * See http://opensource.org/licenses/gpl-license.php
 * 
 ****************************************************************/

class Page
{
   public static function renderMain($idx)
	{
	XHTML::htmlStart();
	XHTML::title(Config::title());
	XHTML::head(URLTOP."Theme/".Config::theme().".css", URLTOP."favicon.ico");
	XHTML::bodyStart();
	XHTML::titleBlock($idx);
	if (!Database::dbExists(ABSP."/Data/InFrame") || Photo::totalPosts() < 1)
		XHTML::adminTip();
	else
	{
		JS::popup();
		JS::verifyChoice();
		Page::renderPhoto($idx);
		Photo::trackViews($idx);
	}
	XHTML::footer();
	XHTML::bodyEnd();
	XHTML::htmlEnd();
	}

	public static function renderAdmin($op, $err)
	{
	XHTML::htmlStart();
	XHTML::title("InFrame Administration");
	XHTML::head(URLTOP."Theme/".Config::theme().".css", URLTOP."favicon.ico");
	XHTML::bodyStart();
	XHTML::titleBlock(-1);
	echo "<div>&nbsp;</div><div>&nbsp;</div>";
	XHTML::adminLinks();
	switch($op)
	{
	case "login":
		XHTML::login($err);
		JS::setFocus("loginForm", "name");
		break;
	case "np":
		XHTML::newPost($err);
		break;
	case "pref":
		XHTML::setPrefs($err);
		JS::setFocus("setPrefsForm", "blogTitle");
		break;
	case "cp":
		XHTML::modOwner($err);
		JS::setFocus("modOwnerForm", "oldPass");
		break;
	default:
		header("Location: ".URLTOP);
	}
	XHTML::footer();
	XHTML::bodyEnd();
	XHTML::htmlEnd();
	}

public static function renderConfigDB()
	{
  	XHTML::htmlStart();
  	XHTML::title("Setup InFrame");
  	XHTML::head(URLTOP."Theme/Snow.css",URLTOP."favicon.ico");
  	XHTML::bodyStart();
  	XHTML::setupDB();
  	JS::setFocus("setupConfigForm", "blogTitle");
	XHTML::footer();
  	XHTML::bodyEnd();
  	XHTML::htmlEnd();
	}

public static function renderLogin($err)
	{
  	XHTML::htmlStart();
  	XHTML::title("Login");
  	XHTML::head(URLTOP."Theme/".Config::theme().".css",URLTOP."favicon.ico");
  	XHTML::bodyStart();
	XHTML::titleBlock(-1);
  	XHTML::login($err);
  	JS::setFocus("loginForm", "name");
	XHTML::footer();
  	XHTML::bodyEnd();
  	XHTML::htmlEnd();
	}

public static function renderComments($i)
{
  	XHTML::htmlStart();
  	XHTML::title("Comments");
  	XHTML::head(URLTOP."Theme/".Config::theme().".css",URLTOP."favicon.ico");
  	XHTML::bodyStart();
	XHTML::titleBlock(-1);
  	XHTML::comments($i);
  	JS::popup();
  	JS::setFocus("commentForm", "name");
	XHTML::footer();
  	XHTML::bodyEnd();
  	XHTML::htmlEnd();
}

public static function renderEditPost($i, $err)
{
  	XHTML::htmlStart();
  	XHTML::title("Edit Post");
  	XHTML::head(URLTOP."Theme/".Config::theme().".css",URLTOP."favicon.ico");
  	XHTML::bodyStart();
	XHTML::titleBlock(-1);
  	XHTML::editPost($i, $err);
  	JS::setFocus("editPostForm", "photoTitle");
	XHTML::footer();
  	XHTML::bodyEnd();
  	XHTML::htmlEnd();
}

public static function listPosts()
{
  	XHTML::htmlStart();
  	XHTML::title("Edit Posts");
  	XHTML::head(URLTOP."Theme/".Config::theme().".css",URLTOP."favicon.ico");
  	XHTML::bodyStart();
	XHTML::titleBlock(-1);
	echo "<div>&nbsp;</div><div>&nbsp;</div>";
	if (User::isLoggedIn())
	{
		XHTML::adminLinks();
		JS::verifyChoice();
	}
	Photo::showPosts();
	XHTML::footer();
  	XHTML::bodyEnd();
  	XHTML::htmlEnd();
}

public static function renderPhoto($i)
	{
	$f = Photo::fileName($i);
	$ext = substr($f, strrpos($f, '.') + 1);
	list($w, $h) = getimagesize(ABSP."/Data/Image/".basename($f, ".".$ext)."-disp.png");
	$w += 16;
	
	echo "<div id=\"photomain\" style=\"width: ".$w."px\">\n";
	if (Photo::title($i) == "Untitled")
		echo "<div id=\"top\">&nbsp;\n";
	else
		echo "<div id=\"top\"><span id=\"ptitle\">".stripcslashes(Photo::title($i))."</span>\n";
	if (Config::showDate())
		echo "<br /><span id=\"date\">".Photo::dateAdded($i)."</span></div>\n";
	else
		echo "<br /><span id=\"date\">&nbsp;</span></div>\n";

	Photo::displayPhoto($i);
	
	echo "<div id=\"bottom\">\n";
	if (Photo::caption($i) != "none")
		echo "<span id=\"caption\">".stripcslashes(Photo::caption($i))."</span>\n";
	else
		echo "<span id=\"caption\">&nbsp;</span>\n";

	echo "<span id=\"bright\">\n";
	if (Config::allowComments() || Config::allowRatings())
	{
		if (Config::allowComments())
		{
			echo "<span id=\"comments\">\n";
			Comments::showLink($i);
			echo "</span>\n";
		}
		if (Config::allowRatings())
		{
			echo "<span id=\"rating\">\n";
			Ratings::showStars($i);
			echo "</span>\n";
		}
	}
	echo "<span id=\"pn\">\n";

	if (Config::pso() == "Shuffle")
		echo "<a href=\"".URLTOP."index.php?id=".Photo::getID("Random")."\"><img src=\"".URLTOP."Theme/".Config::theme()."/previous.png\" title=\"Previous photo\" /></a>\n";
	else if (Database::hasPrev(ABSP."/Data/InFrame", $i))
		echo "<a href=\"".URLTOP."index.php?id=".Database::prevID(ABSP."/Data/InFrame", $i)."\"><img src=\"".URLTOP."Theme/".Config::theme()."/previous.png\" title=\"Previous photo\" /></a>\n";
	
	if (Config::showViews())
	{	
		echo Photo::views($i)." views ";
		if (User::isLoggedIn() && Photo::views($i) > 0)
			echo "<span style=\"font-size: 10px;\"> (<a href=\"".URLTOP."index.php?op=rv&id=".$i."\">reset views</a>)</span>\n";
	}
	
	if (Config::showPosts())
		echo Photo::totalPosts()." posts ";
		
	if (Config::pso() == "Shuffle")
		echo "<a href=\"".URLTOP."index.php?id=".Photo::getID("Random")."\"><img src=\"".URLTOP."Theme/".Config::theme()."/next.png\" title=\"Next photo\" /></a>\n";
	else if (Database::hasNext(ABSP."/Data/InFrame", $i))
		echo "<a href=\"".URLTOP."index.php?id=".Database::nextID(ABSP."/Data/InFrame", $i)."\"><img src=\"".URLTOP."Theme/".Config::theme()."/next.png\" title=\"Next photo\" /></a>\n";

	echo "</span></span>\n";

	if (Photo::desc($i) != "none")
		echo "<p class=\"desc\">".stripcslashes(Photo::desc($i))."</p>\n";
	else
		echo "<p class=\"desc\">&nbsp;</p>\n";
		
	echo "</div></div>\n";
	}
}
?>
