<?php
/****************************************************************
 * This file is part of InFrame
 * Copyright (c) 2008 Richard Tong. All Rights Reserved.
 * 
 * Licensed under the terms of the GNU General Public License.
 * See http://opensource.org/licenses/gpl-license.php
 * 
 ****************************************************************/

class Ratings
{
   public static function createDB($dbname)
   {
     $db = new FFDB();
     $schema = array(
		array("id", FFDB_INT_AUTOINC, "key"),
     	array("photoid", FFDB_INT),
     	array("dateadded", FFDB_STRING),
     	array("ip", FFDB_STRING),
     	array("rating", FFDB_INT));
     $db->create($dbname, $schema);
     $db->close();
     unset($db);
     unset($schema);
     unset($dbname);
   }
   
   public static function saveRating($dbname, $id, $ra)
   {
   	 $db = new FFDB();
   	 $db->open($dbname);
     $record["photoid"] = (int)$id;
     $record["dateadded"] = date('l, M jS Y, \a\t h:ia');
     $record["ip"] = $_SERVER['REMOTE_ADDR']; 
     $record["rating"] = (int)$ra;
     
     $result = $db->add($record);
     $db->close();
     unset($db);
     unset($record);
     if ($result)
     	return true;
     else
     	return false;
	}
   
	public static function totalRatings()
	{
		$db = new FFDB();
		$db->open(ABSP."/Data/Ratings");
		$size = $db->size();
		$db->close();
		unset($db);
		return $size;
   }

	public static function totalRatingsByID($i)
	{
		$db = new FFDB();
		$db->open(ABSP."/Data/Ratings");
		$records = $db->getbyfield("photoid", "/".$i."/i");
		$db->close();
		unset($db);
		return count($records);
   }

	public static function deleteRatingsByID($i)
	{
		$db = new FFDB();
		$db->open(ABSP."/Data/Ratings");
		$result = $db->removebyfield("photoid", "/".$i."/i");
		$db->cleanup();
		$db->close();
		unset($db);
		return $result;
   }

	public static function photoRating($i)
	{
		$db = new FFDB();
		$db->open(ABSP."/Data/Ratings");
		$records = $db->getbyfield("photoid", "/".$i."/i");
		$db->close();
		unset($db);
		if (count($records) > 0)
		{
			$num = 0;
			$rating = 0;
			foreach ($records as $record)
			{
				$rating += $record["rating"];
				$num++;
			}
			return round($rating / $num,2);
		}
		else
			return 0;
   }

	public static function showRatings($i)
	{
		$db = new FFDB();
		$db->open(ABSP."/Data/Ratings");
		$records = $db->getbyfield("photoid", "/".$i."/i");
		$db->close();
		unset($db);
		foreach ($records as $record)
		{
			echo "<p class=\"codate\">Rated ".$record["rating"]." on ".$record["dateadded"]."</p>\n";
		}
   }
	public static function showStars($i)
	{
		echo "
		<a href=\"".URLTOP."index.php?op=cra&id=".$i."&rating=1\" title=\"Rate 1\"><img src=\"".URLTOP."Theme/".Config::theme()."/filledheart.png\" /></a>
		<a href=\"".URLTOP."index.php?op=cra&id=".$i."&rating=2\" title=\"Rate 2\"><img src=\"".URLTOP."Theme/".Config::theme()."/filledheart.png\" /></a>
		<a href=\"".URLTOP."index.php?op=cra&id=".$i."&rating=3\" title=\"Rate 3\"><img src=\"".URLTOP."Theme/".Config::theme()."/filledheart.png\" /></a>
		<a href=\"".URLTOP."index.php?op=cra&id=".$i."&rating=4\" title=\"Rate 4\"><img src=\"".URLTOP."Theme/".Config::theme()."/filledheart.png\" /></a>
		<a href=\"".URLTOP."index.php?op=cra&id=".$i."&rating=5\" title=\"Rate 5\"><img src=\"".URLTOP."Theme/".Config::theme()."/filledheart.png\" /></a>
		<span style=\"font-size: 18px;\" onMouseOver=\"popup('".Ratings::totalRatingsByID($i)." votes')\" onMouseOut=\"popout()\">".Ratings::photoRating($i)."</span>";
		if (User::isLoggedIn() && Ratings::totalRatingsByID($i) > 0 && Config::allowRatings())
					echo "<span style=\"font-size: 10px;\"> (<a href=\"".URLTOP."index.php?op=rr&id=".$i."\">reset rating</a>)</span>\n";
    }

	public static function isUnique($i)
	{
		$db = new FFDB();
		$db->open(ABSP."/Data/Ratings");
		$records = $db->getbyfield("photoid", "/".$i."/i");
		$db->close();
		unset($db);
		$ipAddr = $_SERVER["REMOTE_ADDR"];
		$unique = true;
		if (count($records) > 0)  // there are some ratings for this photo
		{
			foreach ($records as $record)
				if ($ipAddr == $record["ip"])
					$unique = false;
		}
		return $unique;
   }

}
?>
