<?php
/****************************************************************
 * This file is part of InFrame
 * Copyright (c) 2008 Richard Tong. All Rights Reserved.
 * 
 * Licensed under the terms of the GNU General Public License.
 * See http://opensource.org/licenses/gpl-license.php
 * 
 ****************************************************************/

class XHTML
{
   public static function htmlStart()
   {
	 echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n";
	 echo "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">\n";
   }
   
   public static function title($title)
   {
	 echo "<title>".stripslashes($title)."</title>\n";
   }
   
   public static function head($css,$favicon)
   {
	 echo "<head><link href=\"$css\" rel=\"stylesheet\" type=\"text/css\">\n";
	 echo "<link rel=\"shortcut icon\" href=\"$favicon\"></head>\n";
   }
   
   public static function bodyStart()
   {
	 echo "<body>\n";
   }
   
   public static function bodyEnd()
   {
	 echo "</body>\n";
   }
   
   public static function htmlEnd()
   {
	 echo "</html>\n";
   }
   
   public static function titleBlock($i)
   {
	if (file_exists(ABSP."/Image/banner.png"))
	{
	 	echo "<div id=\"banner\">";
	}
	else
	{
	 	echo "<div id=\"titleBlock\">
	 		<span id=\"title\">".stripslashes(Config::title())."</span>\n";
	}
	
   	if (User::isLoggedIn())
	{
		echo "<span id=\"ilink\"><a href=\"".URLTOP."\">home</a> 
			&nbsp;&nbsp;<a href=\"".URLTOP."Admin/admin.php\">admin</a>";
		if ($i >= 0 && Database::dbExists(ABSP."/Data/InFrame"))
			if (Photo::totalPosts() > 0)
			{
				echo "&nbsp;&nbsp;<a href=\"".URLTOP."index.php?op=ep&id=".$i."\">edit photo</a>\n";
				echo "&nbsp;&nbsp;<a href=\"".URLTOP."index.php?op=dpo&id=".$i."\" onClick=\"return verify()\">delete photo</a>\n";
			if (Config::allowBrowse() && Photo::totalPosts() > 1)
				echo "&nbsp;&nbsp;<a href=\"".URLTOP."index.php?op=epl\">browse</a>";
			if (Config::allowRandom() && Photo::totalPosts() > 1)
				echo "&nbsp;&nbsp;<a href=\"".URLTOP."index.php?id=".Photo::getID("Random")."\">random</a>";
			}
		if (file_exists(ABSP."/about.html"))
			echo "&nbsp;&nbsp;<a href=\"".URLTOP."about.html\">about</a>";
		echo "&nbsp;&nbsp;<a href=\"".URLTOP."Admin/admin.php?op=lo\">logout</a></span>";
	}
	else
	{
		echo "<span id=\"ilink\"><a href=\"".URLTOP."\">home</a>";
		if (Database::dbExists(ABSP."/Data/InFrame"))
			if (Photo::totalPosts() > 1)
			{
				if (Config::allowBrowse())
					echo "&nbsp;&nbsp;<a href=\"".URLTOP."index.php?op=epl\">browse</a>";
				if (Config::allowRandom())
					echo "&nbsp;&nbsp;<a href=\"".URLTOP."index.php?id=".Photo::getID("Random")."\">random</a>";
			}
		if (file_exists(ABSP."/about.html"))
			echo "&nbsp;&nbsp;<a href=\"".URLTOP."about.html\">about</a>";
		echo "</span>";
	}

	if (!file_exists(ABSP."/Image/banner.png"))
 		if (Config::byline() != "none")
 			echo "<span id=\"tagline\">".stripslashes(Config::byline())."</span>\n";

	echo "</div><div>&nbsp;</div>\n";

   }
   
   public static function externalLinks()
   {
	 echo "<p id=\"elink\"></p>\n";
   }

   public static function adminLinks()
   {
   	 echo "<div id=\"abar\">";
	 echo "<span id=\"alink\"><a href=\"".URLTOP."Admin/admin.php?op=np\">new post</a></span>\n";
	 echo "<span id=\"alink\"><a href=\"".URLTOP."Admin/admin.php?op=pref\">set prefs</a></span>\n";
	 echo "<span id=\"alink\"><a href=\"".URLTOP."Admin/admin.php?op=cp\">change password</a></span>\n";
	 if (Database::dbExists(ABSP."/Data/InFrame"))
		echo "<span id=\"alink\"><a href=\"".URLTOP."Admin/admin.php?op=epl\">browse posts</a></span>\n";
	 echo "</div>";
   }

   public static function footer()
   {
	 echo "<p id=\"footer\"><a href=\"http://sourceforge.net/projects/InFrame\"><img src=\"".URLTOP."Image/if-logo-small.png\" /></a>&nbsp;&nbsp;
	 	<a href=\"http://www.mozilla.com/firefox\"><img title=\"Download Firefox for best results\" src=\"".URLTOP."Image/FF3o80x15_square.gif\" /></a>
	 	&nbsp;&nbsp;<a href=\"".URLTOP."feed\"><img title=\"RSS feed\" src=\"".URLTOP."Image/feed-icon-14x14.png\" /></a></p>\n";
   }

public static function adminTip()
{
	echo "<div>&nbsp;</div><div>&nbsp;</div>
		<p style=\"height: 650px; text-align: center;\">There are no photos in your blog. You should visit the 
		<a href=\"".URLTOP."Admin/admin.php\">Admin</a> page and create a new post.</p>\n";
}

public static function newPost($err)
{
	echo "<form enctype=\"multipart/form-data\" name=\"newPostForm\" method=\"post\" action=\"admin.php?op=cnp\" onsubmit=\"return validate_form(this)\">
	<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"8000000\" />\n";
	if ($err)
		echo "<p id=\"error\">There was an error creating your post. Please try again.</p>\n";
	echo "<fieldset>
		<legend>Create a new post</legend>
		<table>
		<tr><td>Upload:</td>
		<td><input class=\"formInput\" type=\"file\" name=\"photoFilename\" size=\"30\" /></td></tr>
		<tr><td>Photo title:</td>
		<td><input class=\"formInput\" type=\"text\" name=\"photoTitle\" size=\"40\" /></td></tr>
		<tr><td>Photo caption:</td>
		<td><input class=\"formInput\" type=\"text\" name=\"photoCaption\" size=\"40\" /></td></tr>";

	if (Config::alwaysDelete())
		echo "<tr><td>&nbsp;</td><td><input type=\"checkbox\" name=\"delete\" checked=\"checked\" /> Delete uploaded file (on server) after processing</td></tr>\n";
	else
		echo "<tr><td>&nbsp;</td><td><input type=\"checkbox\" name=\"delete\" /> Delete uploaded file (on server) after processing</td></tr>\n";

	echo "<tr><td>&nbsp;</td></tr>";
	echo "<tr><td colspan=\"2\">Description (All HTML is stripped, but newlines are preserved)</td></tr>
		<tr><td colspan=\"2\"><textarea class=\"formInput\" name=\"photoDesc\" cols=\"80\" rows=\"15\"></textarea></td></tr>
		<tr><td colspan=\"2\" align=\"right\"><input type=\"submit\" value=\"Create post\"></td></tr>
		</table></fieldset>
		</form>\n";
	JS::validate("photoFilename", "You need to choose a file to upload!");
}

public static function setPrefs($err)
{
	echo "<form name=\"setPrefsForm\" method=\"post\" action=\"admin.php?op=cpref\">\n";
	if ($err)
		echo "<p id=\"error\">There was an error in setting your preferences. Please try again.</p>\n";
	echo "<fieldset>
		<legend>Preferences</legend>
		<table>
		<tr><td>Blog Title:</td>
		<td><input class=\"formInput\" type=\"text\" name=\"blogTitle\" size=\"40\" value=\"".stripslashes(Config::title())."\" /></td></tr>
		<tr><td>Catch phrase:</td>
		<td><input class=\"formInput\" type=\"text\" name=\"byline\" size=\"40\" value=\"".stripslashes(Config::byline())."\" /></td></tr>
		<tr><td>&nbsp;</td></tr>
		<tr><td>Theme: <select class=\"formInput\" name=\"theme\" />\n";
		
	foreach (scandir(ABSP."/Theme") as $Theme)
	  if (preg_match("/.css/i", $Theme))
	  	if (basename($Theme, ".css") == Config::theme())
		    echo "<option selected=\"selected\" value=\"".basename($Theme, ".css")."\">".basename($Theme, ".css")."</option>\n";
		else
		    echo "<option value=\"".basename($Theme, ".css")."\">".basename($Theme, ".css")."</option>\n";
	echo "</select></td>\n";

	echo "<td align=\"right\">Post sort order: <select class=\"formInput\" name=\"pso\">
		<option value=\"".Config::pso()."\">".Config::pso()."</option>\n";
		
	if (Config::pso() == "Newest first")
	{
		echo "<option value=\"Oldest first\">Oldest first</option>\n";
		echo "<option value=\"Shuffle\">Shuffle</option>\n";
	}
	else if (Config::pso() == "Oldest first")
	{
		echo "<option value=\"Newest first\">Newest first</option>\n";
		echo "<option value=\"Shuffle\">Shuffle</option>\n";
	}
	else
	{
		echo "<option value=\"Newest first\">Newest first</option>\n";
		echo "<option value=\"Oldest first\">Oldest first</option>\n";
	}
		
	echo "</select></td></tr>
		<tr><td>&nbsp;</td></tr>
		<tr><td colspan=\"2\">Display dimensions (the displayed image will be resized to this value on the longest side)</td></tr>
		<tr><td>Width: <input class=\"formInput\" type=\"text\" name=\"dimx\" size=\"6\" value=\"".Config::dimX()."\" /></td>
			<td>Height: <input class=\"formInput\" type=\"text\" name=\"dimy\" size=\"6\" value=\"".Config::dimY()."\" /></td></tr>\n";
	
	echo "<tr><td>&nbsp;</td></tr>";
	echo "<tr>\n";
	if (Config::allowComments())
		echo "<td><input type=\"checkbox\" name=\"comment\" checked=\"checked\" />\n";
	else
		echo "<td><input type=\"checkbox\" name=\"comment\" />\n";
	echo "Allow comments</td>\n";

	if (Config::allowRatings())
		echo "<td><input type=\"checkbox\" name=\"rating\" checked=\"checked\" />\n";
	else
		echo "<td><input type=\"checkbox\" name=\"rating\" />\n";
	echo"Allow ratings</td>\n";
	echo "</tr>\n";
	
	echo "<tr>\n";
	if (Config::allowViewExif())
		echo "<td><input type=\"checkbox\" checked=\"checked\" name=\"viewExif\" />\n";
	else
		echo "<td><input type=\"checkbox\" name=\"viewExif\" />\n";
	echo"Show EXIF data</td>\n";

	if (Config::showViews())
		echo "<td><input type=\"checkbox\" checked=\"checked\" name=\"showviews\" />\n";
	else
		echo "<td><input type=\"checkbox\" name=\"showviews\" />\n";
	echo"Show post views</td>\n";
	echo "</tr>\n";

	echo "<tr>\n";
	if (Config::showPosts())
		echo "<td><input type=\"checkbox\" name=\"showposts\" checked=\"checked\" />\n";
	else
		echo "<td><input type=\"checkbox\" name=\"showposts\" />\n";
	echo"Show total blog posts</td>\n";
	
	if (Config::showOriginal())
		echo "<td><input type=\"checkbox\" checked=\"checked\" name=\"original\" />\n";
	else
		echo "<td><input type=\"checkbox\" name=\"original\" />\n";
	echo"View original photo</td>\n";
	echo "</tr>\n";

	echo "<tr>\n";
	if (Config::allowRandom())
		echo "<td><input type=\"checkbox\" checked=\"checked\" name=\"showrandom\" />\n";
	else
		echo "<td><input type=\"checkbox\" name=\"showrandom\" />\n";
	echo"Random post</td>\n";

	if (Config::allowBrowse())
		echo "<td><input type=\"checkbox\" checked=\"checked\" name=\"browse\" />\n";
	else
		echo "<td><input type=\"checkbox\" name=\"browse\" />\n";
	echo"Browse posts</td>\n";
	echo "</tr>\n";

	echo "<tr>\n";
	if (Config::requireUniqueComment())
		echo "<td><input type=\"checkbox\" checked=\"checked\" name=\"uniqueComment\" />\n";
	else
		echo "<td><input type=\"checkbox\" name=\"uniqueComment\" />\n";
	echo"Unique comments</td>\n";

	if (Config::requireUniqueRating())
		echo "<td><input type=\"checkbox\" checked=\"checked\" name=\"uniqueRating\" />\n";
	else
		echo "<td><input type=\"checkbox\" name=\"uniqueRating\" />\n";
	echo"Unique ratings</td>\n";
	echo "</tr>\n";

	echo "<tr>\n";
	if (Config::requireCaptcha())
		echo "<td><input type=\"checkbox\" checked=\"checked\" name=\"captcha\" />\n";
	else
		echo "<td><input type=\"checkbox\" name=\"captcha\" />\n";
	echo"Require captcha to comment</td>\n";
	if (Config::alwaysDelete())
		echo "<td><input type=\"checkbox\" checked=\"checked\" name=\"alwaysdelete\" />\n";
	else
		echo "<td><input type=\"checkbox\" name=\"alwaysdelete\" />\n";
	echo"Always delete uploaded photo</td>\n";
	echo "</tr>\n";

	echo "<tr>\n";
	if (Config::showDate())
		echo "<td><input type=\"checkbox\" checked=\"checked\" name=\"showdate\" />\n";
	else
		echo "<td><input type=\"checkbox\" name=\"showdate\" />\n";
	echo"Show post date/timestamp</td>\n";
	echo "<td>&nbsp;</td>";
	echo "</tr>\n";

/*	echo "<tr>\n";
	if (Config::showBooks())
		echo "<td><input type=\"checkbox\" checked=\"checked\" name=\"showbooks\" />\n";
	else
		echo "<td><input type=\"checkbox\" name=\"showbooks\" />\n";
	echo"Enable books</td>\n";
	echo "<td>&nbsp;</td>\n";
	echo "</tr>\n";
*/
/*
	if (Config::showGrayBar())
		echo "<p class=\"formText\"><input class=\"formInput\" type=\"checkbox\" checked=\"checked\" name=\"graybar\" />\n";
	else
		echo "<p class=\"formText\"><input class=\"formInput\" type=\"checkbox\" name=\"graybar\" />\n";
	echo"Show the Zone System gray bar</p>\n";
*/
	echo"<tr><td colspan=\"2\" align=\"right\"><input type=\"submit\" value=\"Set prefs\"></td></tr>\n";
	echo "</table>\n";
	echo "</fieldset></form>\n";
}

public static function modOwner($err)
{
	echo "<form name=\"modOwnerForm\" method=\"post\" action=\"admin.php?op=ccp\">\n";
	if ($err)
		echo "<p id=\"error\">There was an error changing your password. Please try again.</p>\n";
	echo "<fieldset>
		<legend>Change password for ".Config::owner()."</legend>
		<table>
		<tr><td>Old password:</td>
		<td><input class=\"formInput\" type=\"password\" name=\"oldPass\" size=\"20\" /></td></tr>
		<tr><td>New password:</td>
		<td><input class=\"formInput\" type=\"password\" name=\"newPass\" size=\"20\" /></td></tr>
		<tr><td>Retype new password:</td>
		<td><input class=\"formInput\" type=\"password\" name=\"verifyPass\" size=\"20\" /></td></tr>
		<tr><td colspan=\"2\" align=\"right\"><input type=\"submit\" value=\"Change password\"></td></tr>
		</table></fieldset>
		</form>\n";
}

public static function setupDB()
{
  echo "<p id=\"heading\">Setup InFrame</p>
		<p class=\"regText\">Let's configure your photo blog.</p>
		<form name='setupConfigForm' method='post' action='setup.php?op=cdb'>
		<fieldset>
		<legend>Preferences</legend>
		<p class=\"formText\">Title</p>
		<input class=\"formInput\" type=\"text\" name=\"blogTitle\" size=\"40\" value=\"InFrame\" />
		<p class=\"formText\">Catch phrase (May be left blank)</p>
		<input class=\"formInput\" type=\"text\" name=\"byline\" size=\"40\" value=\"where the photo is the blog\" />
		<p class=\"formText\">Theme</p>
		<select class=\"formInput\" name=\"theme\" />\n";
		foreach (scandir(ABSP."/Theme") as $Theme)
		  if (preg_match("/.css/i", $Theme))
		    echo "<option value=\"".basename($Theme, ".css")."\">".basename($Theme, ".css")."</option>\n";
  echo "</select>
		</fieldset>
		<fieldset>
		<legend>Blog Owner</legend>
		The default name and password is admin/admin.
		<p class=\"formText\">Name</p>
		<input class=\"formInput\" type=\"text\" name=\"owner\" size=\"15\" value=\"admin\" />
		<p class=\"formText\">Password</p>
		<input class=\"formInput\" type=\"password\" name=\"password\" size=\"15\" value=\"admin\" />
		<p><input type=\"submit\" value=\"Continue >>\" /></p>
		</fieldset>
		</form>\n";
}

public static function login($err)
{
	echo "<div>&nbsp;</div><div>&nbsp;</div>";
	if ($err)
		echo "<p id=\"error\">Incorrect login. Please try again.</p>\n";
	echo "<form name=\"loginForm\" method=\"post\" action=\"admin.php?op=clogin\">
		<fieldset>
		<table>
		<tr><td>Name:</td>
		<td><input class=\"formInput\" type=\"text\" name=\"name\" size=\"20\" /></td></tr>
		<tr><td>Password:</td>
		<td><input class=\"formInput\" type=\"password\" name=\"pw\" size=\"20\" /></td></tr>
		<tr><td colspan=\"2\" align=\"right\"><p><input type=\"submit\" value=\"Login\"></p></td></tr>
		</table>
		</fieldset>
		</form>\n";
}

public static function comments($i)
{
	$f = Photo::fileName($i);
	$ext = substr($f, strrpos($f, '.') + 1);
	echo "<div>&nbsp;</div>\n";
	echo "<fieldset>
		<legend>Comment on ".Photo::title($i)."</legend>\n";
	echo "<table><tr><td><img style=\"border: 2px solid #ccc; margin-right: .2in;\" src=\"".URLTOP."Data/Image/".basename($f, ".".$ext)."-thumb.png\" /></td>\n";
	echo "<td valign=\"top\">\n";
	if (Comments::totalCommentsByID($i) > 0)
		echo Comments::showComments($i);
	else
		echo "<td>There are no comments for this post yet.</td>\n";
	echo "</td>\n";
	echo "</tr></table>\n";
	
	echo "<form name=\"commentForm\" method=\"post\" action=\"".URLTOP."index.php?op=cco&id=".$i."\">
		<table><tr><td>&nbsp;</td></tr>\n";
	echo "<tr><td>Your name:</td>
		<td><input class=\"formInput\" type=\"text\" name=\"name\" size=\"25\" /></td></tr>
		<tr><td>Your homepage:</td>
		<td><input class=\"formInput\" type=\"text\" name=\"homepage\" size=\"25\" value=\"http://\" /></td></tr>
		<tr><td colspan=\"2\">Comment</td></tr>
		<tr><td colspan=\"2\"><textarea class=\"formInput\" name=\"comment\" cols=\"64\" rows=\"6\"></textarea></td></tr>\n";
	
	if (Config::requireCaptcha())
	{
		echo "<tr><td valign=\"top\">Enter captcha text:</td>
			<td><input class=\"formInput\" type=\"text\" name=\"captcha_code\" size=\"10\" maxlength=\"6\" /><br />
			<img id=\"captcha\" src=\"".URLTOP."securimage/securimage_show.php\" /></td></tr>\n";
	}
	
	echo "<tr><td colspan=\"2\" align=\"right\"><input type=\"submit\" value=\"Send comment\"></td></tr></table>
		</fieldset>
		</form>\n";
}

public static function editPost($i, $err)
{
	$f = Photo::fileName($i);
	$ext = substr($f, strrpos($f, '.') + 1);
	echo "<div>&nbsp;</div>\n";
	echo "<form enctype=\"multipart/form-data\" name=\"editPostForm\" method=\"post\" action=\"index.php?op=cep&id=".$i."\">";
	if ($err)
		echo "<p id=\"error\">There was an error editing your post. Please try again.</p>\n";
	echo "<fieldset>
		<legend>Edit post</legend>";
	echo "<table><tr><td valign=\"top\"><img style=\"border: 2px solid #ccc; margin-right: .2in;\" src=\"".URLTOP."Data/Image/".basename($f, ".".$ext)."-thumb.png\" /></td>\n";
	echo "<td valign=\"top\"><table><tr><td>Photo title:</td>
		<td><input class=\"formInput\" type=\"text\" name=\"photoTitle\" size=\"40\" value=\"".stripcslashes(Photo::title($i))."\" /></td></tr>
		<tr><td>Photo caption:</td>
		<td><input class=\"formInput\" type=\"text\" name=\"photoCaption\" size=\"40\" value=\"".stripcslashes(Photo::caption($i))."\" /></td></tr>
		<tr><td colspan=\"2\">Description</td></tr>
		<tr><td colspan=\"2\"><textarea class=\"formInput\" name=\"photoDesc\" cols=\"80\" rows=\"15\">".stripcslashes(str_replace("<br />", "\n", Photo::desc($i)))."</textarea></td></tr>
		<tr><td colspan=\"2\" align=\"right\"><input type=\"submit\" value=\"Update post\"></td></tr>
		</table></td></tr></table>
		</fieldset>
		</form>\n";
}

}
?>
