<?php
/****************************************************************
 * This file is part of InFrame
 * Copyright (c) 2008 Richard Tong. All Rights Reserved.
 * 
 * Licensed under the terms of the GNU General Public License.
 * See http://opensource.org/licenses/gpl-license.php
 * 
 ****************************************************************/

// Config file
$configFile = "Config/InFrame.config.php";
if (file_exists($configFile))
  require_once($configFile);
else
{
  Util::saveNewPaths();
  unset($configFile);
  header("Location: Admin/setup.php");
}

// Config database
if (!Database::dbExists("Data/Config"))
{
  header("Location: Admin/setup.php");
}

session_start();
require_once ("securimage/securimage.php");
$securimage = new Securimage();


$op = $_GET["op"];
if (!isset($op))
	$op = "view";

$id = $_GET["id"];
if (!isset($id))
{
	if (Database::dbExists(ABSP."/Data/InFrame") && Photo::totalPosts() > 0)
	{
		$id = Photo::getID(Config::pso());
	}
}

switch($op)
{
	case "view":
		Page::renderMain((int)$id);
		break;
	case "co":
		Page::renderComments((int)$id);
		break;
	case "ep":
		Page::renderEditPost((int)$id, false);
		break;
	case "epl":
		if (Config::allowBrowse())
			Page::listPosts();
		else
			header("Location: index.php");
		break;
	case "rr":
		if (User::isLoggedIn())
			Ratings::deleteRatingsByID((int)$id);
		header("Location: index.php?op=view&id=".$id);
		break;
	case "rv":
		if (User::isLoggedIn())
			Photo::resetViews((int)$id);
		header("Location: index.php?op=view&id=".$id);
		break;
	case "cep":
		if (User::isLoggedIn())
			Photo::saveEditedPost(ABSP."/Data/InFrame", (int)$id, strip_tags($_POST["photoTitle"]), strip_tags($_POST["photoCaption"]), str_replace("\n", "<br />", strip_tags($_POST["photoDesc"])));
		header("Location: index.php?op=view&id=".$id);
		break;
	case "cec":
		$idx = $_GET["idx"];
		if (User::isLoggedIn())
			Comments::saveEditedComment(ABSP."/Data/Comments", (int)$idx, strip_tags($_POST["comment"]));
		header("Location: index.php?op=co&id=".$id);
		break;
	case "dco":
		$idx = $_GET["idx"];
		if (User::isLoggedIn())
			Comments::deleteComment(ABSP."/Data/Comments", (int)$idx);
		header("Location: index.php?op=co&id=".$id);
		break;
	case "bco":
		if (User::isLoggedIn() && !IP::isBlocked($_GET["ip"]))
			IP::block($_GET["ip"]);
		header("Location: index.php?op=co&id=".$id);
		break;
	case "dpo":
		if (User::isLoggedIn())
			Photo::deletePost(ABSP."/Data/InFrame", (int)$id);
		header("Location: index.php");
		break;
	case "cco":
		$pass = false;

		if (isset($_POST["comment"]))  // blank name=Anonymous, but comment must have content
			$pass = true;
		if (Config::requireUniqueComment())
			if (!Comments::isUnique((int)$id))
				$pass = false;
		if (Config::requireCaptcha())
			if (!$securimage->check($_POST['captcha_code']))
				$pass = false;
		if ($pass && !IP::isBlocked($_SERVER["REMOTE_ADDR"]))
			Comments::saveComment(ABSP."/Data/Comments", (int)$id, strip_tags($_POST["name"]), strip_tags($_POST["homepage"]), strip_tags($_POST["comment"]));
		Page::renderMain((int)$id);
		break;
	case "cra":
			if (Config::requireUniqueRating())
			{
				if (Ratings::isUnique($id))
					Ratings::saveRating(ABSP."/Data/Ratings", (int)$id, $_GET["rating"]);
			}
			else
				Ratings::saveRating(ABSP."/Data/Ratings", (int)$id, $_GET["rating"]);
		Page::renderMain((int)$id);
		break;
	default:
		header("Location: index.php");
}

function __autoload($class_name)
{
  require_once 'Class/' . $class_name . '.class.php';
}

?>
